#!/usr/bin/python3

import os
import time
from bloonix.logger import logger
from bloonix.procmanager import ProcManager

class WorkerAAA:
    def __init__(self):
        self.log = logger("bloonix")
        self.log.add(type="screen")
        self.log.info("init WorkerAAA")

    def run(self, pm):
        self.log.info("WorkerAAA: child pid =", os.getpid())
        while pm.done is False:
            self.log.info("WorkerAAA:", os.getpid(), "hello world")
            time.sleep(3)
        self.log.info("WorkerAAA:", os.getpid(), "child quit")


class WorkerBBB:
    def __init__(self):
        self.log = logger("bloonix")
        self.log.add(type="screen")
        self.log.info("WorkerBBB: init")

    def run(self, pm):
        self.log.info("WorkerBBB: child pid =", os.getpid())
        while pm.done is False:
            self.log.info("WorkerBBB:", os.getpid(), "hello world")
            time.sleep(3)
        self.log.info("WorkerBBB:", os.getpid(), "child quit")


class Parent:
    def __init__(self):
        self.log = logger("bloonix")
        self.log.add(type="screen")

        self.pm = ProcManager(
            signal_hup_callback=self.reload,
            signal_term_callback=self.terminate)

        self.pm.add_pool(
            name="worker-aaa",
            worker=3,
            callback=WorkerAAA().run)
        self.pm.add_pool(
            name="worker-bbb",
            worker=3,
            callback=WorkerBBB().run)

    def run(self):
        self.log.info("parent pid =", os.getpid())
        self.pm.daemonize()

    def reload(self):
        self.log.info("reload() called")

    def terminate(self):
        self.log.info("termiate() called")


Parent().run()
