#!/usr/bin/python3

import os
import time
from bloonix.logger import logger
from bloonix.procmanager import ProcManager

log = logger("bloonix")
log.add(type="screen")
print(os.getpid(), "parent start")

def callback_reload():
    print(os.getpid(), "HUP")

def callback_quit():
    print(os.getpid(), "QUIT")

def run_worker(pm):
    while pm.done is False:
        print(os.getpid(), "worker")
        time.sleep(3)

pm = ProcManager(
    signal_hup_callback=callback_reload,
    signal_term_callback=callback_quit
)

pm.add_pool(
    name="test",
    worker=3,
    callback=run_worker,
)
pm.daemonize()
