#!/usr/bin/python3

import os
import time
from bloonix.logger import logger
from bloonix.procmanager import ProcManager

log = logger("bloonix")
log.add(type="screen")
print(os.getpid(), "parent start")

def callback_reload():
    print(os.getpid(), "HUP")

def callback_quit():
    print(os.getpid(), "QUIT")

def run_worker(pm, num1, num2, num3, foo, bar, baz):
    print(num1, num2, num3, foo, bar, baz)
    while pm.done is False:
        print(os.getpid(), "worker")
        time.sleep(3)

pm = ProcManager()

pm.add_pool(
    name="test",
    worker=3,
    callback=run_worker,
    args=[1,2,3],
    kwargs={"foo": 4, "bar": 5, "baz": 6},
)
pm.daemonize()
